import simu.*;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.image.*;
import java.awt.Image;

import java.awt.Color;



/**
 * Class extending SimuApplet. It is used to display the delaunay triangulation on the sphere.
 */
public class Display_t extends SimuApplet {

    //private Vector listeCellule;

	
    private int nPoint;
    int mode;
    private int nProj;
    private SquareGrid grid;
    private Vector cellList;
    
	
    /**
     * Constructor of Display inheriting SimuApplet
     */
    public Display_t() {
	appletDoc("delaunay.xml");
	//listCellule = new listeCellule();
    }


    




    
	public ListeValeurs calcul(ListeValeurs in) throws SimuException {

	    double facteur = 100;
        
	    nProj=0;
	    nPoint=in.lireEntier("nPoint");
	
	    // int mode = 3;

	    grid = new SquareGrid(nPoint);
	    
	    cellList = grid.getCells();
	    
	    
	     String tempS = in.lireString("mode");

	     if (tempS.equals("Delauney")){
		 mode=1;
	     }
	     else if (tempS.equals("Voronoi")){
		 mode=2;
	     }
	     else if (tempS.equals("Delauney et Voronoi")){
		 mode=3;
	     }


	    Image img = createImage(600, 400);
	    Graphics g = (img).getGraphics();


	   

	    ListeValeurs out = new ListeValeurs();

	    if( mode==1 || mode==3){
	    for (int i= 0 ; i<cellList.size(); i++){

		Cell c = (Cell)cellList.elementAt(i);
	    
		Vector  neigh = c.getNeighbours();
	    

		Vector xy = c.getCartCoordinates();
	
		double xp = ((Double)xy.elementAt(0)).doubleValue();
		double yp = ((Double)xy.elementAt(1)).doubleValue();
		int x1 = (int)(xp*facteur*3/nPoint) + (int)(0.05*facteur);
		int y1 = (int)(yp*facteur*3/nPoint)+ (int)(0.05*facteur);
	    
		for (int j =0; j<neigh.size(); j++){ 

		    Cell n = (Cell)neigh.elementAt(j);

		    
		    Vector xyN = n.getCartCoordinates();
		    
		    double xpN = ((Double)xyN.elementAt(0)).doubleValue();
		    double ypN = ((Double)xyN.elementAt(1)).doubleValue();
		    
		    int x2 = (int)(xpN*facteur*3/nPoint) + (int)(0.05*facteur);
		    int y2 = (int)(ypN*facteur*3/nPoint) + (int)(0.05*facteur);
		    
		    g.drawLine(x1,y1,x2,y2);
		    
		}
	    }
	    }

	    if( mode==2 || mode==3){
	    for (int i= 0 ; i<cellList.size(); i++){

		g.setColor(Color.red);

		Cell c = (Cell)cellList.elementAt(i);
	    
		Vector  vor = c.getVoronoi();
		
		Vector xyc = c.getCartCoordinates();
		double xc = ((Double)xyc.elementAt(0)).doubleValue();
		double yc = ((Double)xyc.elementAt(1)).doubleValue();

		
		
		if (!( (yc < ((double)nPoint+0.6)) && (yc> ((double)nPoint+0.4)) )){
		}
		else if (!( (xc < ((double)nPoint+0.6)) && (xc> ((double)nPoint+0.4)) )){
		}
		else{
		
		
		//Point p0 = (Point)vor.elementAt(0);
		for (int j =0; j<vor.size(); j++){ 

		    Point p = (Point)vor.elementAt(j);
		    Point q;
		    
		    if(j < (vor.size()-1)){
			q = (Point)vor.elementAt(j+1);
		    }
		    else{
			q = (Point)vor.elementAt(0);
		    }

		    

			Vector xyp = p.getCartCoordinates();
			
			double xp = ((Double)xyp.elementAt(0)).doubleValue();
			double yp = ((Double)xyp.elementAt(1)).doubleValue();
			
			int x1 = (int)(xp*facteur*3/nPoint) + (int)(0.05*facteur);
			int y1 = (int)(yp*facteur*3/nPoint) + (int)(0.05*facteur);



			Vector xyq = q.getCartCoordinates();
			
			double xq = ((Double)xyq.elementAt(0)).doubleValue();
			double yq = ((Double)xyq.elementAt(1)).doubleValue();
			
			int x2 = (int)(xq*facteur*3/nPoint) + (int)(0.05*facteur);
			int y2 = (int)(yq*facteur*3/nPoint) + (int)(0.05*facteur);
			
			
			g.drawLine(x1,y1,x2,y2);
		    
			}
		}
	    }
	    }
	
	//System.out.println("-----xp : " + xp);
	//System.out.println("     yp : " + yp);

	out.ajouter("diagramme", img);
	
	

	return out;

	}
}
