import java.util.Vector;
import java.lang.Math.*;



/**
 * Class which represents a node of the location structure.
 */
public class GraphNode{

    private Triangle trian;
    private Vector childList; 
    private LocationStructure loc;



    /**
     * Constructor of GraphNode
     * @param t the associated triangle
     * @param loca the associated LocationStructure object
     */
    public GraphNode(Triangle t, LocationStructure loca){
	trian = t;
	childList = new Vector();
	loc = loca;
    }

    /**
     * Adds a child to the node
     * @param node the node added in the child list
     */
    public void addChild(GraphNode node){
	childList.addElement(node);
    }


    /**
     * Getter for the associated triangle
     * @return trian the associated triangle
     */
    public Triangle getTriangle(){
	return trian;
    }


    /**
     * Getter for the child list
     * @return childList the associated child list
     */
    public Vector getChildList(){
	return childList;
    }



    /** 
     * Returns the first summit different between the two nodes 
     * @param node the GraphNode to be compared with
     */
    public Point difference(GraphNode node){

	Triangle tr = node.getTriangle();

	Point p1 = tr.getS1();
	Point p2 = tr.getS2();
	Point p3 = tr.getS3();
	
	
	Point pcomp = trian.getS1();
	if ( (pcomp!=p1) && (pcomp!=p2) && (pcomp!=p3) ){
	    return pcomp;
	}

	pcomp = trian.getS2();
	if ( (pcomp!=p1) && (pcomp!=p2) && (pcomp!=p3) ){
	    return pcomp;
	}

	pcomp = trian.getS3();
	if ( (pcomp!=p1) && (pcomp!=p2) && (pcomp!=p3) ){
	    return pcomp;
	}
	else{
	    return null;
	}
    }


}
