import java.util.Vector;


/**
 * Interface for the meshing of an object 
 */
public interface Grid {


    /**
     * Returns a Vector containing all the cells of the grid
     * @return Vector containing all the cells
     */
    public Vector getCells();


   
    /**
     * Returns the root cell. The root cell has all the cells as neighbours with equi-probabilities.
     * @return the root cell
     */
    public Cell getRoot();

    
    /**
     * Returns the coordinates of the associated projection.
     * @return the root cell
     */
    public Vector projec(Cell c);



}
