import java.util.*;
import simu.*;
import java.awt.Graphics;
import java.awt.image.*;
import java.awt.Image;

import java.awt.Color;

/** 
  * Create a grain with a square grid or a sphericalgrid, then move the particules, get and plot their position and their lifetime.
  */
public class Main extends SimuApplet  {
	
		
	private double density, densisite;
	private double diameter;
	private double x;
	private double y;
	private int    i,d;
	private int initialParticleNumber;
	private Grain	grain;	
	private EventManager eventmanager;
	private static Grid grid;
	private int e;
	private double tevaporation;
	private int evap2, evap;
	private int x1,x2,y1,y2, xp, yp, xnc,ync, xcc, ycc;
	private Vector deltat;
	private double deltattemp;
	private double temp;
	private double nombre;
	private int nombre_elements;
	private String affichage, maillage;
	private Vector xy, xy1;
	private int nombredesite;
	private Image img;
	private Graphics g;
	private Vector cellList;
	private int nPoint;
        private double facteur=130;
        private double facteurX1;
        private double facteurX2;
        private double facteurY1;
        private double facteurY2;
        private double bT, cT;
	private	double temperature;
	private double Tgrain;
	private int    test=0;
	private Cell   cc,nc; 
	private double pause;

	public  Main() {
		appletDoc("H2_doc.xml");
		
	
	}
	
		


	public void initCalculLive(ListeValeurs in) throws SimuException {
		x = 0;
		y = 0;
		i=0;
		d=0;

		Tgrain=in.lireDouble("tgrain");
		if (temperature<0){
			throw new SimuException("la temprature doit tre positive");
		}
		temperature = in.lireDouble("temperature");
		if (temperature<0){
			throw new SimuException("la temprature doit tre positive");
		}

		density	    = in.lireDouble("density");
		diameter    = in.lireDouble("diameter");
		initialParticleNumber=in.lireEntier("initialParticleNumber");

		if (initialParticleNumber==0){
			throw new SimuException("le nombre initial de particules doit tre au moins 1");
		}

		affichage = in.lireString("affichage");
		densisite = in.lireDouble("densisite");
		maillage=in.lireString("maillage");
		pause=in.lireDouble("pause");

				

		
		grain=new Grain(diameter,temperature);
		nombredesite=(int) (densisite*Math.PI*diameter*diameter);
		nPoint=(int) diameter;
		
		if (nombredesite>1000){
			throw new SimuException("le nombre total de site est trop gros, merci de diminuer le diamtre du grain ou bien la densit de site sur le grain");
		}

		if (nombredesite<4){
			throw new SimuException("le nombre total de site est trop faible, merci d'augmenter le diamtre du grain ou bien la densit de site sur le grain");
		}		

		System.out.println("j'ai choisi " +maillage);
		if (maillage.equals("torique")) {
		    //	grid= new SquareGrid((int) (diameter*Math.sqrt(densisite)));
			grid= new SquareGrid((int) Math.sqrt(nombredesite));
		}
		if (maillage.equals("spherique")){
			grid= new SphereGrid((int) nombredesite);
		}
		eventmanager=new EventManager(initialParticleNumber,grid, density, temperature,Tgrain, diameter, densisite);
		deltat = new Vector();

		
		
		//getaffichage
		
		nombre_elements=0;
		e=0;
		evap=0;
		evap2=0;
		temp=0.;
		tevaporation=0.;
		evap2=0;
		y=0;
		x=0;
		test=0;
		//////////////////////////////////////////////////////////////////////////////
        //ON DESSINE LE MAILLAGE

	   	cellList = grid.getCells();
		
		img = createImage(800, 600);
 		g = (img).getGraphics();
 		g.setColor(Color.black);
	
	   	 for (int i= 0 ; i<cellList.size(); i++){

			int x1=0;
			int y1=0;

			Cell c = (Cell)cellList.elementAt(i);

			Vector  neigh = c.getNeighbours();

			double phiC = ((Double)(c.getSphereCoordinates()).elementAt(2)).doubleValue();


			Vector xy = grid.projec(c);
	
			double xp = ((Double)xy.elementAt(0)).doubleValue();
			double yp = ((Double)xy.elementAt(1)).doubleValue();
			
			if (maillage.equals("torique")) {
				x1 = (int)(xp*facteur*3/nPoint) + (int)(0.05*facteur);
				y1 = (int)(yp*facteur*3/nPoint)+ (int)(0.05*facteur);
			}

			if (maillage.equals("spherique")) {
				x1 = (int)(xp*facteur)+ (int)(3.0*facteur);
				y1 = (int)(yp*facteur)+ (int)(1.8*facteur);
			}
	
			g.fillOval(x1-5,y1-5,10,10);

			

			for (int j =0; j<neigh.size(); j++){ 

			    Cell n = (Cell)neigh.elementAt(j);

				Vector xyN = grid.projec(n);
				double xpN = ((Double)xyN.elementAt(0)).doubleValue();
				double ypN = ((Double)xyN.elementAt(1)).doubleValue();

				if (maillage.equals("torique")) {
					int x2 = (int)(xpN*facteur*3/nPoint) + (int)(0.05*facteur);
		   			int y2 = (int)(ypN*facteur*3/nPoint) + (int)(0.05*facteur);
					g.drawLine(x1,y1,x2,y2);
					g.fillOval(x2-5,y2-5,10,10);
				}

				if (maillage.equals("spherique")) {
					double phiN = ((Double)(n.getSphereCoordinates()).elementAt(2)).doubleValue();
					if ( (Math.PI >=  phiC) && (phiC >= (Math.PI)/2.0) && (phiN >= Math.PI) && (phiN<=(3.0*Math.PI/2.0)))
					{
					}
			    		else if ( (Math.PI >=  phiN) && (phiN >= (Math.PI)/2.0) && (phiC >= Math.PI) && (phiC<=(3.0*Math.PI/2.0)) )
					{
					}
		 		else{
				
					int x2 = (int)(xpN*facteur) + (int)(3.0*facteur);
					int y2 = (int)(ypN*facteur) + (int)(1.8*facteur);
					g.drawLine(x1,y1,x2,y2);
					g.fillOval(x2-5,y2-5,10,10);
				}

				}
			    }
			}
	    	}


	


public ListeValeurs calculLive() throws SimuException {

		ListeValeurs out = new ListeValeurs();

		//On rafraichit les informations que lorsqu'on a une evaportation, l'affichage de la carte est mauvais
		if ("on".equals(affichage)){
			
			
			while (e==0){
				
				
			   	 bT=((Particle) eventmanager.getEventVector().elementAt(0)).getBirthTime();

				eventmanager.move();	
				
				cT=eventmanager.getTime();

			        xy=grid.projec(((Cell) ((Particle) eventmanager.getEventVector().elementAt(0)).getCurrentCell ()));

				x=(int)(((Double) xy.elementAt(0)).doubleValue());

				y=(int)(((Double) xy.elementAt(1)).doubleValue());
						
				tevaporation=tevaporation+1;
			 
				if (cT!=bT){
					e=(eventmanager.getEvap());
				}
			}

						
		        deltat.insertElementAt(new Double(cT-bT),0);
			
			
			evap2=evap2+1;
			temp=tevaporation;
			e=0;

			nombre_elements = deltat.size();
	
			if (nombre_elements > 1) {
				for (int i = 0; i < nombre_elements - 1; i++) {
					Double t0 = (Double) deltat.elementAt(i);
					Double t1 = (Double) deltat.elementAt(i+1);
					
					if (t0.doubleValue() > t1.doubleValue()) {
						// exchange the two elements
						deltat.setElementAt(t1, i);
						deltat.setElementAt(t0, i + 1);				
					}
					
				}			
			}	

			out.ajouterDouble("x", x);
			out.ajouterDouble("y", y);
			out.ajouterDouble("evap",evap);

			for (int j=0; j< evap2; j++){
				out.ajouterDouble("nombre",((double) Math.log(1-j/ ((double) evap2))));
				out.ajouterDouble("tevap",((Double) deltat.elementAt(j)).doubleValue());
				
				}
	
			int taille=( eventmanager.getEventVector().size());
			out.ajouterString("nombredepoints", "nombre de particules sur le grain : "+taille);
			
			int indice=0;
			for (i = 0; i<grid.getCells().size(); i++){
				if (((Cell) grid.getCells().elementAt(i)).getOccupied()==-1){
				indice=indice+1;
				}
			}g.setColor(Color.green);
			g.fillOval(xnc-3,ync-3,6,6);

			g.setColor(Color.blue);
			g.fillOval(xcc-3,ycc-3,6,6);
			dormir(100);

		
			out.ajouterDouble("particlenumber",eventmanager.getParticleNumber());

			indice=grid.getCells().size()-indice;
			out.ajouter("carte", img);
			out.ajouterDouble("time",cT);
			}

		//On rafraichit les informations  chaque mouvement, l'affichage de la fonction de rpartition est mauvais
		if ("off".equals(affichage)){
	
			if (d==1){
				g.setColor(Color.black);
				g.fillOval(xcc-5,ycc-5,10,10);

				g.setColor(Color.red);
				g.fillOval(xnc-5,ync-5,10,10);
				
			}
			d=1;
			
			
			
			cc=(Cell) ((Particle) eventmanager.getEventVector().elementAt(0)).getCurrentCell ();
			nc=(Cell) ((Particle) eventmanager.getEventVector().elementAt(0)).getNextCell ();
			
			eventmanager.move();

			xy=grid.projec(cc);
			x=(((Double) xy.elementAt(0)).doubleValue());
			y=(((Double) xy.elementAt(1)).doubleValue());
				
			if (maillage.equals("torique")) {
			
				xcc = (int)(x*facteur*3/nPoint) + (int)(0.05*facteur);
                                ycc = (int)(y*facteur*3/nPoint)+ (int)(0.05*facteur);

		         }

			if (maillage.equals("spherique")) {
			   	xcc = (int)(x*facteur)+ (int)(3.0*facteur);
				ycc = (int)(y*facteur)+ (int)(1.8*facteur);
			}	


			
			xy=grid.projec(nc);
			x=(((Double) xy.elementAt(0)).doubleValue());
			y=(((Double) xy.elementAt(1)).doubleValue());
				
			if (maillage.equals("torique")) {
			
				xnc = (int)(x*facteur*3/nPoint) + (int)(0.05*facteur);
                                ync = (int)(y*facteur*3/nPoint)+ (int)(0.05*facteur);

		         }

			if (maillage.equals("spherique")) {
			   	xnc = (int)(x*facteur)+ (int)(3.0*facteur);
				ync = (int)(y*facteur)+ (int)(1.8*facteur);
			}	


			
			

			g.setColor(Color.blue);
			g.fillOval(xcc-5,ycc-5,10,10);
			
			g.setColor(Color.green);
			g.fillOval(xnc-5,ync-5,10,10);
			
				

			tevaporation=tevaporation+1;
			e=(eventmanager.getEvap());
				
			deltat.insertElementAt(new Double(tevaporation-temp),0);
			evap2=evap2+1;
			temp=tevaporation;
			e=0;

			nombre_elements = deltat.size();
	
			out.ajouterDouble("x", x);
			out.ajouterDouble("y", y);
			out.ajouterDouble("evap",evap);

			for (int j=0; j< evap2; j++){
				out.ajouterDouble("nombre",((double) evap2));
				out.ajouterDouble("tevap",((Double) deltat.elementAt(j)).doubleValue());
				
			}
	
			int taille=( eventmanager.getEventVector().size());
			out.ajouterString("nombredepoints", "nombre de particules sur le grain : "+taille);
			
			int indice=0;
			for (i = 0; i<grid.getCells().size(); i++){
				if (((Cell) grid.getCells().elementAt(i)).getOccupied()==-1){
				indice=indice+1;
				}
			}
			indice=grid.getCells().size()-indice;
			int index1=((Particle) eventmanager.getEventVector().elementAt(0)).getIndex();
			
			//dormir(10); // pour bloquer le programme pendant 1 secondes
			
			cT=eventmanager.getTime();

			out.ajouter("carte", img);
			out.ajouterDouble("particlenumber",eventmanager.getParticleNumber());
			out.ajouterDouble("time", cT);
			dormir( (int) (10*pause));
		}
			
			

		return out;

	}
	
//METHODES

 /** 
  * Return the grid
  */

	public static Grid getGrid(){
		return grid;
	}

}	

