import java.util.*;

public class Particle {

 /**
  * attributes 
  */
  

 /** 
  * index of the last particle arrived 
  */ 
   private static int lastIndex = 0;        // !!! à initialiser !!!

 /** 
  * particle index (useful to find a particle) 
  */
   private int index;

 /** 
  * created particle time of arrival 
  */			
   private double birthTime;
	
 /** 
  * cell on which is the particle 
  */	
   private Cell currentCell;	

   private double tau;
 /** 
  * particle composition 
  */	
   private int composition;		
   
 /** 
  * next move time 
  */
   private double nextMoveTime;	

 /** 
  * next cell on which particle move at nextMoveTime 
  */	
   private Cell nextCell;		


 /** 
  * default class constructor 
  */

   public Particle () {
     						  	
   }



 /** 
  * class constructor with arguments
  * @param bT time of arrival of the particle on the grain
  * @param cC cell from which the particle arrive
  * @param nMT
  */

   public Particle (double bT, Cell nC, double temps) {
     
    // !!! il faut demander à créer une nouvelle particule qui représenterait l'espace (ie une cellule
    // qui serait hors du grain et qui aurait pour voisin tous les voisins.

     int index = lastIndex+1; // le nouvel index est l'index de la dernière particule +1
     lastIndex = index;
     tau=temps;
     birthTime = bT;	// date ou l'on crée la particule (ie ou on appelle ce constructeur)
     nextCell = nC;  // cellule hors du grain dont les voisins sont toutes les cellules du maillage
     nextMoveTime = bT; // date à laquelle la particule va rentrer sur le grain. (liée au flux de particule dans l'espace, à T ... tout ce qui se rapporte au flux extérieur étant géré par EventManager)
     currentCell=nextCell;
    // nextCell = createNextCell(); La particule arrivant n'a pas de current cell mais a un next cell
						  	
   }


/**************************** methodes d'acquisition ******************************/


 /** 
  * @return particle index
  */
   public int getIndex () {
  
     return index;
   }

 /** 
  * @return cell on which is the particle 
  */
   public Cell getCurrentCell () {
  
     return currentCell;
   }

 /** 
  * @return created particle time of arrival 
  */
  public double getBirthTime () {
  
     return birthTime;
   }

 /** 
  * @return particle composition 
  */
  public int getComposition () {
  
     return composition;
   }

 /** 
  * @return particle composition 
  */
  public double getNextMoveTime () {
  
     return nextMoveTime;
   }

 /** 
  * @return next cell on which particle move at nextMoveTime 
  */
  public Cell getNextCell () {
  
     return nextCell;
   }
  public void setBirthTime(double bT){
	birthTime=bT;
  }

  public void setNextCell(Cell nC){
 	nextCell=nC;
  }
/*******************************************************************************/

 

 /**
  * méthode de déplacement d'une Cell à l'autre
  */

   public void move () {

     currentCell = nextCell;
     nextMoveTime = createNextMoveTime();
     nextCell = createNextCell();
   }



 /** 
  * calculation to find the next move time
  * @return time of the next move
  */
   
   public double createNextMoveTime () {
     
     Random generator = new Random ();
       	// !!! donner une valeur à tau 

     double rand = generator.nextDouble();
   
     double calculatedNextMoveTime = nextMoveTime - Math.log(rand)*tau;   // donne une loi en exp(-t/tau)

     return calculatedNextMoveTime;
 
   }



 /** 
  * calculation to find the Next Cell 
  * @return cell on which the particle will go on the next step
  */

   public Cell createNextCell () {
     
     Random generator = new Random ();
     
     // pour le moment le choix est équiprobable mais on peut à l'avenir le pondérer.


     Vector neighbours = currentCell.getNeighbours();        // we get the neighbourhood ... 
     int size = neighbours.size();			     // ... and the number of neighbours 
     int indexCell = (int) ( size*generator.nextDouble() );  // we choose uniformly an index among all

     Cell calculatedNextCell = (Cell) ( neighbours.elementAt(indexCell) );			

     return calculatedNextCell;

   }



}
